/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024  Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//NPM Imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const {exceptionHandler, errorHandler} = require('../../../utils/loggerUtils');
const {userModel} = require('../../../schemas/userSchema');
const channelModel = require('../../../schemas/channel/channelSchema');

//api account functions
module.exports.post = async function(req, res){
    try{
        //Get validation result
        const validResult = validationResult(req);
        
        //If we data is valid
        if(validResult.isEmpty()){
            //Set channel object from sanatized/validated data, and get user document from session data
            const channel = matchedData(req);
            const userDB = await userModel.findOne({user: req.session.user.user});

            //register new channel with requesting user as owner
            await channelModel.register(channel, userDB);
            return res.sendStatus(200);
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}